#!/usr/bin/python

# bibfindauth.py version 1 author Tamara Polajnar (t.polajnar@dcs.shef.ac.uk)

# this program takes a bib file and finds all the entries where the people 
# listed in a given file (by default bibfindauth-list.txt) appear either as 
# authors or editors.
# author names should go Last First Middle. Middle names are optional.

# usage: ./bibfindauth.py [<sourcebibfile> [<authorsfile>]]
import sys
import re

aF = "bibfindauth-list.txt"
sF = "../big.bib"
rF = "bibfindauth-results.bib"

state = 0
author = re.compile("author\s+=")
editor = re.compile("editor\s+=") 
word = re.compile("\S+")
authors = {}

# open files (add checking)
if len(sys.argv) > 1:
    sF = sys.argv[1]
    if len(sys.argv) > 2:
	aF = sys.argv[2]

authFile = open(aF)
sourceFile = open(sF)
resultFile = open(rF, 'w')


# get the names 
for name in authFile.readlines():
    w =  word.findall(name)
    if w != [] and name[0] != '#':
	second = w[0].lower()
	if not(authors.has_key(second)): 
	    authors[second] = []
	if len(w) == 1:
	    authors[second] = [re.compile("\s+"+second)]
	elif len(w) > 1:    
	    first = w[1].lower()
	    authors[second].append(re.compile("\s+"+first[0]+".\s+" +second))
	    authors[second].append(re.compile("\s+"+first[0]+"\s+" +second))
	    authors[second].append(re.compile("\s+"+first +"\s+" +second))
	    authors[second].append(re.compile(second + ",\s+" + first[0]))
	    authors[second].append(re.compile(second + ",\s+" + first))
	
	# if there is a middle name
	if len(w) > 2:
	    middle = w[2].lower()
	    authors[second].append(re.compile(first[0]+"."+ middle[0]\
					       +".\s+"+second))
	    authors[second].append(re.compile(first[0]+"\s+"+ middle[0]\
					       +"\s+"+second))

	    authors[second].append(re.compile(first+"\s+"+ middle+"\s+"+second))


start = re.compile("@")
ename = re.compile("\{(.+),")
popen = re.compile("\{")
pclose = re.compile("\}")
lines = 0
entries = {}
paren = 0

entry = ""
keepFlag = 0
l = sourceFile.readline()
while 1:
    line = l
    l = l.lower()
     
    if state == 0:
	if start.findall(l) != []:                    
	    # start of a new entry	
	    if keepFlag == 1:
		entries[entryName[0]] = entry
		keepFlag = 0
	    entryName = ename.findall(l)
	    entry = line
	       
	    state = 1
	    paren = 1
	else:
	    entry += line

    if state ==1:
	if start.findall(l) != []:                    
	    # start of a new entry 
	    if keepFlag == 1:
		entries[entryName[0]] = entry
		keepFlag = 0	
	    entry = line
	    entryName = ename.findall(l)
	    pren = 0
	elif author.findall(l) != [] or editor.findall(l) != []:
	    state = 2
	    entry += line

	    
	paren += len(popen.findall(l))
	paren -= len(pclose.findall(l))
	
	if paren == 0:
	    state = 0


    if state == 2:
	state = 1
	l = l.replace('~', ' ')
	parenBefore = paren
	paren += len(popen.findall(l))
	paren -= len(pclose.findall(l))
	for a in authors:
	    for reg in authors[a]:
		if reg.findall(l) != []:
		    state = 0
		    lines +=1
		    keepFlag = 1
# comment out if you want the program to check for multiline author entries
# this piece of code slows it down a little bit		    
	while keepFlag == 0 and paren != parenBefore:
	    l = sourceFile.readline()
	    entry += l
	    l = l.lower()
	    if l == "":
		break
	    
	    for a in authors:
		for reg in authors[a]:
		    if reg.findall(l) != []:
			state = 0
			lines +=1
			keepFlag = 1
	    paren += len(popen.findall(l))
	    paren -= len(pclose.findall(l))

    l = sourceFile.readline()
    if l == "":
       break


print "RESULTS (in file bibfindauth-results.bib):"
print lines

# output to result file
for e in entries:
    resultFile.write(entries[e])
resultFile.close()
